Fix building with Linux <2.6.9 headers (bug #317937).
authorArfrever Frehtes Taifersar Arahesis <arfrever@gentoo.org>
Mon, 12 Jul 2010 19:11:19 +0000 (19:11 +0000)
committerArfrever Frehtes Taifersar Arahesis <arfrever@gentoo.org>
Mon, 12 Jul 2010 19:11:19 +0000 (19:11 +0000)
Fix httplib.HTTPResponse.read() (bug #321545).
Fix vulnerabilities in audioop module (bug #325593).
Backport some fixes from 2.6 branch.

Package-Manager: portage-HEAD/cvs/Linux x86_64

dev-lang/python/ChangeLog
dev-lang/python/Manifest
dev-lang/python/python-2.6.5-r3.ebuild [new file with mode: 0644]

index 8c509c8065313fb518b2764bd25f942dd66d20b1..165d6ab795b5f258a433c221d5a734130b79d328 100644 (file)
@@ -1,6 +1,14 @@
 # ChangeLog for dev-lang/python
 # Copyright 1999-2010 Gentoo Foundation; Distributed under the GPL v2
-# $Header: /var/cvsroot/gentoo-x86/dev-lang/python/ChangeLog,v 1.476 2010/07/04 21:16:21 arfrever Exp $
+# $Header: /var/cvsroot/gentoo-x86/dev-lang/python/ChangeLog,v 1.477 2010/07/12 19:11:19 arfrever Exp $
+
+*python-2.6.5-r3 (12 Jul 2010)
+
+  12 Jul 2010; Arfrever Frehtes Taifersar Arahesis <arfrever@gentoo.org>
+  +python-2.6.5-r3.ebuild:
+  Fix building with Linux <2.6.9 headers (bug #317937). Fix httplib.HTTPResponse.read()
+  (bug #321545). Fix vulnerabilities in audioop module (bug #325593). Backport some
+  fixes from 2.6 branch.
 
 *python-2.7 (04 Jul 2010)
 
index 52ff04f0a67419e6020be89857bd408a88b93a51..ad1c3d2e67f4d030fad8a0af383fd11f434cf3ca 100644 (file)
@@ -15,13 +15,15 @@ DIST python-gentoo-patches-2.4.6.tar.bz2 10983 RMD160 c06dc76edec86d708a0c0e3712
 DIST python-gentoo-patches-2.5.4-r3.tar.bz2 19473 RMD160 c3a807693103f9e26c3cce4add5a1f3d975ef216 SHA1 c6170894865ee8aac8c813916c21a0d0458691bc SHA256 03f5bdb0a4ac8eb498a90c5cd444a5c76ed7e79bff5e8dca00efe77cf80c6391
 DIST python-gentoo-patches-2.6.4-r1.tar.bz2 12570 RMD160 2a58eb651ce5adc68c4667fb0ddc42cc215ea342 SHA1 c5de0442890bc0753c445a88390d932e629c8648 SHA256 2fe6c8838df2c07d3232ebb26c128dab2787c43a76ddb0b55acec1bed657f9f2
 DIST python-gentoo-patches-2.6.5-r4.tar.bz2 68611 RMD160 63a67a772df32dcf1977c1060228f5282a332a41 SHA1 e29469ff9800ff3125d203eea152bfdf378b7234 SHA256 7497892864469a9ff8698dcd6467cb6ddadd3b8472e8847b9e27f738ff7962ab
+DIST python-gentoo-patches-2.6.5-r5.tar.bz2 1482491 RMD160 a7978912b8598a589a82746642fa5b676369c599 SHA1 26c983e79ac32b63a3bc6e411d96b9233524733b SHA256 6cb8cf0e1418cad035a243c08dfeee2e9395397dda74ada49667b3eba63bb76c
 DIST python-gentoo-patches-2.7.tar.bz2 11803 RMD160 a4bef5c904859f530f6cf5009ac60d171c34af00 SHA1 06b3f6077febed0aa807cb81cd689215efc430c6 SHA256 c72446007ab1b4dd0d8702b0901a8b5e8eadb1ce6872e7f99e12f4eb97874b0f
 DIST python-gentoo-patches-3.1.2-r5.tar.bz2 67359 RMD160 0ee5576b7de728a0840c6020d8403b94a883eeaa SHA1 5900a751c7e6fea512f79e045aa2f7870e378595 SHA256 fa5eabe0cc84789e9ed2fd6140dfdf08ca29de00474b117b9998b0eefc2e850a
 EBUILD python-2.4.6.ebuild 9295 RMD160 ceafad3166524ebb3bb89c58efb8aff255053dd1 SHA1 8545e8b5671180216a863170213bd3f95666518c SHA256 03b17693ea85c22aeb13c3105330cf0aebaf9f9e241b0cc81a03c39cf5c959e0
 EBUILD python-2.5.4-r4.ebuild 9645 RMD160 21881a4d1f0e8245b1821109ab26e775d55e94c6 SHA1 2c1b8b54b5ec5902521d9e9017d669c67ae15160 SHA256 c6dc2f20bf1edbbdee06ab87ed5618d0f5e07172c212a51cb44a86df706591c1
 EBUILD python-2.6.4-r1.ebuild 9579 RMD160 63713df2187e8f3adc35038b26e58fc8e4cf8e4f SHA1 05640ba05170caff47cf8998d6ac1ad127a682a2 SHA256 5fb3de2f4f6b9b13c16c8f0b452bde4057a8a889a828920762b4c4c02e2aad98
 EBUILD python-2.6.5-r2.ebuild 9457 RMD160 fb08e8c4752c4315bf13c5b48e72c3b07b9ea78d SHA1 bce39b4bfd449cd99a84ab6dbf57c8d0ad239c2e SHA256 3f10f5e35d942dfce1262ab067b257e158f0a8738f3e55361914dc711437aca8
+EBUILD python-2.6.5-r3.ebuild 9452 RMD160 992d239730bbb901eb186b996f2cdeb0b7bc2b3d SHA1 aeb39e95a7b8ac219ce1d99eddeef3e7ec556564 SHA256 6564b86e7de3374a976f127343ee62c9cd4abbd2bcc7d0de32685520c6d48404
 EBUILD python-2.7.ebuild 9743 RMD160 43381e34f2e2494b348c4e26365e8579642deac8 SHA1 5061119a80c0992bd83805210029c5dad88cdfbb SHA256 92bc8e51588d143647f42b52cf867efdcc57a044c1b06f285ee6b7fe3f414af3
 EBUILD python-3.1.2-r3.ebuild 9256 RMD160 98cc9afd66714d449f272fac82fcaff9d74e499f SHA1 382ee98785de1f57cff37ef63efb9477e7c96413 SHA256 e39e3dde3e40b6fca08cf681a32fdb126be1ae8f6f7ff4ac75c207d7a5e893ba
-MISC ChangeLog 84599 RMD160 c4536e24c621c5a9495ce5c07983b084cbb2b753 SHA1 0d747eea895eb42af3eeb48be13b5158cb559e3f SHA256 c7e91a69fbc70c5435a1c20ccfc7e310e6d911eecd37038739cd7dd9e121cc9a
+MISC ChangeLog 84929 RMD160 e5e9491485ef479ecfbd04a8786cc971b2e74c2e SHA1 a4de75c2aa21b137e184c834b1f96bf4919e007a SHA256 6f9d2649dbc66c786ad77194120228ecadb03a1199d86ed4bed738622f8a6246
 MISC metadata.xml 661 RMD160 54831d16b8807086bfabdbb3df9d33336b5d42a0 SHA1 9867c337fe9e6f4e967004fc9409763e0fedf43b SHA256 2c6c3407251f7ccd6501dee49494e539a9544f2fbae99a4373eefdf4e83e8908
diff --git a/dev-lang/python/python-2.6.5-r3.ebuild b/dev-lang/python/python-2.6.5-r3.ebuild
new file mode 100644 (file)
index 0000000..2d407ff
--- /dev/null
@@ -0,0 +1,311 @@
+# Copyright 1999-2010 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header: /var/cvsroot/gentoo-x86/dev-lang/python/python-2.6.5-r3.ebuild,v 1.1 2010/07/12 19:11:19 arfrever Exp $
+
+EAPI="2"
+
+inherit autotools eutils flag-o-matic multilib pax-utils python toolchain-funcs
+
+MY_P="Python-${PV}"
+
+PATCHSET_REVISION="5"
+
+DESCRIPTION="Python is an interpreted, interactive, object-oriented programming language."
+HOMEPAGE="http://www.python.org/"
+SRC_URI="http://www.python.org/ftp/python/${PV}/${MY_P}.tar.bz2
+       mirror://gentoo/python-gentoo-patches-${PV}$([[ "${PATCHSET_REVISION}" != "0" ]] && echo "-r${PATCHSET_REVISION}").tar.bz2"
+
+LICENSE="PSF-2.2"
+SLOT="2.6"
+PYTHON_ABI="${SLOT}"
+KEYWORDS="~alpha ~amd64 ~arm ~hppa ~ia64 ~m68k ~mips ~ppc ~ppc64 ~s390 ~sh ~sparc ~x86 ~sparc-fbsd ~x86-fbsd"
+IUSE="-berkdb build doc elibc_uclibc examples gdbm ipv6 +ncurses +readline sqlite +ssl +threads tk +wide-unicode wininst +xml"
+
+RDEPEND=">=app-admin/eselect-python-20091230
+               >=sys-libs/zlib-1.1.3
+               virtual/libffi
+               virtual/libintl
+               !build? (
+                       berkdb? ( || (
+                               sys-libs/db:4.7
+                               sys-libs/db:4.6
+                               sys-libs/db:4.5
+                               sys-libs/db:4.4
+                               sys-libs/db:4.3
+                               sys-libs/db:4.2
+                       ) )
+                       gdbm? ( sys-libs/gdbm )
+                       ncurses? (
+                               >=sys-libs/ncurses-5.2
+                               readline? ( >=sys-libs/readline-4.1 )
+                       )
+                       sqlite? ( >=dev-db/sqlite-3 )
+                       ssl? ( dev-libs/openssl )
+                       tk? ( >=dev-lang/tk-8.0 )
+                       xml? ( >=dev-libs/expat-2 )
+               )
+               doc? ( dev-python/python-docs:${SLOT} )"
+DEPEND="${RDEPEND}
+               dev-util/pkgconfig
+               !sys-devel/gcc[libffi]"
+RDEPEND+=" !build? ( app-misc/mime-types )"
+PDEPEND="app-admin/python-updater"
+
+PROVIDE="virtual/python"
+
+S="${WORKDIR}/${MY_P}"
+
+pkg_setup() {
+       python_pkg_setup
+
+       if use berkdb; then
+               ewarn "\"bsddb\" module is out-of-date and no longer maintained inside dev-lang/python. It has"
+               ewarn "been additionally removed in Python 3. You should use external, still maintained \"bsddb3\""
+               ewarn "module provided by dev-python/bsddb3 which supports both Python 2 and Python 3."
+       fi
+}
+
+src_prepare() {
+       # Ensure that internal copies of expat, libffi and zlib are not used.
+       rm -fr Modules/expat
+       rm -fr Modules/_ctypes/libffi*
+       rm -fr Modules/zlib
+
+       if ! tc-is-cross-compiler; then
+               rm "${WORKDIR}/${PV}"/*_all_crosscompile.patch
+       fi
+
+       EPATCH_SUFFIX="patch" epatch "${WORKDIR}/${PV}"
+
+       # Avoid regeneration, which would not change contents of files.
+       touch Include/Python-ast.h Python/Python-ast.c
+
+       sed -i -e "s:@@GENTOO_LIBDIR@@:$(get_libdir):g" \
+               Lib/distutils/command/install.py \
+               Lib/distutils/sysconfig.py \
+               Lib/site.py \
+               Makefile.pre.in \
+               Modules/Setup.dist \
+               Modules/getpath.c \
+               setup.py || die "sed failed to replace @@GENTOO_LIBDIR@@"
+
+       # Fix os.utime() on hppa. utimes it not supported but unfortunately reported as working - gmsoft (22 May 04)
+       # PLEASE LEAVE THIS FIX FOR NEXT VERSIONS AS IT'S A CRITICAL FIX !!!
+       [[ "${ARCH}" == "hppa" ]] && sed -e "s/utimes //" -i "${S}/configure"
+
+       if ! use wininst; then
+               # Remove Microsoft Windows executables.
+               rm Lib/distutils/command/wininst-*.exe
+       fi
+
+       # Fix OtherFileTests.testStdin() not to assume
+       # that stdin is a tty for bug #248081.
+       sed -e "s:'osf1V5':'osf1V5' and sys.stdin.isatty():" -i Lib/test/test_file.py || die "sed failed"
+
+       eautoreconf
+}
+
+src_configure() {
+       # Disable extraneous modules with extra dependencies.
+       if use build; then
+               export PYTHON_DISABLE_MODULES="dbm _bsddb gdbm _curses _curses_panel readline _sqlite3 _tkinter _elementtree pyexpat"
+               export PYTHON_DISABLE_SSL="1"
+       else
+               # dbm module can be linked against berkdb or gdbm.
+               # Defaults to gdbm when both are enabled, #204343.
+               local disable
+               use berkdb   || use gdbm || disable+=" dbm"
+               use berkdb   || disable+=" _bsddb"
+               use gdbm     || disable+=" gdbm"
+               use ncurses  || disable+=" _curses _curses_panel"
+               use readline || disable+=" readline"
+               use sqlite   || disable+=" _sqlite3"
+               use ssl      || export PYTHON_DISABLE_SSL="1"
+               use tk       || disable+=" _tkinter"
+               use xml      || disable+=" _elementtree pyexpat" # _elementtree uses pyexpat.
+               export PYTHON_DISABLE_MODULES="${disable}"
+
+               if ! use xml; then
+                       ewarn "You have configured Python without XML support."
+                       ewarn "This is NOT a recommended configuration as you"
+                       ewarn "may face problems parsing any XML documents."
+               fi
+       fi
+
+       if [[ -n "${PYTHON_DISABLE_MODULES}" ]]; then
+               einfo "Disabled modules: ${PYTHON_DISABLE_MODULES}"
+       fi
+
+       if [[ "$(gcc-major-version)" -ge 4 ]]; then
+               append-flags -fwrapv
+       fi
+
+       filter-flags -malign-double
+
+       [[ "${ARCH}" == "alpha" ]] && append-flags -fPIC
+
+       # https://bugs.gentoo.org/show_bug.cgi?id=50309
+       if is-flagq -O3; then
+               is-flagq -fstack-protector-all && replace-flags -O3 -O2
+               use hardened && replace-flags -O3 -O2
+       fi
+
+       if tc-is-cross-compiler; then
+               OPT="-O1" CFLAGS="" LDFLAGS="" CC="" \
+               ./configure --{build,host}=${CBUILD} || die "cross-configure failed"
+               emake python Parser/pgen || die "cross-make failed"
+               mv python hostpython
+               mv Parser/pgen Parser/hostpgen
+               make distclean
+               sed -i \
+                       -e "/^HOSTPYTHON/s:=.*:=./hostpython:" \
+                       -e "/^HOSTPGEN/s:=.*:=./Parser/hostpgen:" \
+                       Makefile.pre.in || die "sed failed"
+       fi
+
+       # Export CXX so it ends up in /usr/lib/python2.X/config/Makefile.
+       tc-export CXX
+
+       # Set LDFLAGS so we link modules with -lpython2.6 correctly.
+       # Needed on FreeBSD unless Python 2.6 is already installed.
+       # Please query BSD team before removing this!
+       append-ldflags "-L."
+
+       OPT="" econf \
+               --with-fpectl \
+               --enable-shared \
+               $(use_enable ipv6) \
+               $(use_with threads) \
+               $(use wide-unicode && echo "--enable-unicode=ucs4" || echo "--enable-unicode=ucs2") \
+               --infodir='${prefix}/share/info' \
+               --mandir='${prefix}/share/man' \
+               --with-libc="" \
+               --with-system-ffi
+}
+
+src_test() {
+       # Tests will not work when cross compiling.
+       if tc-is-cross-compiler; then
+               elog "Disabling tests due to crosscompiling."
+               return
+       fi
+
+       # Byte compiling should be enabled here.
+       # Otherwise test_import fails.
+       python_enable_pyc
+
+       # Skip failing tests.
+       local skip_tests="distutils httpservers minidom pyexpat sax tcl"
+
+       # test_ctypes fails with PAX kernel (bug #234498).
+       host-is-pax && skip_tests+=" ctypes"
+
+       for test in ${skip_tests}; do
+               mv "${S}/Lib/test/test_${test}.py" "${T}"
+       done
+
+       # Rerun failed tests in verbose mode (regrtest -w).
+       EXTRATESTOPTS="-w" emake test
+       local result="$?"
+
+       for test in ${skip_tests}; do
+               mv "${T}/test_${test}.py" "${S}/Lib/test/test_${test}.py"
+       done
+
+       elog "The following tests have been skipped:"
+       for test in ${skip_tests}; do
+               elog "test_${test}.py"
+       done
+
+       elog "If you would like to run them, you may:"
+       elog "cd '${EPREFIX}$(python_get_libdir)/test'"
+       elog "and run the tests separately."
+
+       python_disable_pyc
+
+       if [[ "${result}" -ne 0 ]]; then
+               die "emake test failed"
+       fi
+}
+
+src_install() {
+       [[ -z "${ED}" ]] && ED="${D%/}${EPREFIX}/"
+
+       emake DESTDIR="${D}" altinstall maninstall || die "emake altinstall maninstall failed"
+       python_clean_installation_image -q
+
+       mv "${ED}usr/bin/python${SLOT}-config" "${ED}usr/bin/python-config-${SLOT}"
+
+       # Fix collisions between different slots of Python.
+       mv "${ED}usr/bin/2to3" "${ED}usr/bin/2to3-${SLOT}"
+       mv "${ED}usr/bin/pydoc" "${ED}usr/bin/pydoc${SLOT}"
+       mv "${ED}usr/bin/idle" "${ED}usr/bin/idle${SLOT}"
+       mv "${ED}usr/share/man/man1/python.1" "${ED}usr/share/man/man1/python${SLOT}.1"
+       rm -f "${ED}usr/bin/smtpd.py"
+
+       if use build; then
+               rm -fr "${ED}usr/bin/idle${SLOT}" "${ED}$(python_get_libdir)/"{bsddb,idlelib,lib-tk,sqlite3,test}
+       else
+               use elibc_uclibc && rm -fr "${ED}$(python_get_libdir)/"{bsddb/test,test}
+               use berkdb || rm -fr "${ED}$(python_get_libdir)/"{bsddb,test/test_bsddb*}
+               use sqlite || rm -fr "${ED}$(python_get_libdir)/"{sqlite3,test/test_sqlite*}
+               use tk || rm -fr "${ED}usr/bin/idle${SLOT}" "${ED}$(python_get_libdir)/"{idlelib,lib-tk}
+       fi
+
+       use threads || rm -fr "${ED}$(python_get_libdir)/multiprocessing"
+
+       prep_ml_includes $(python_get_includedir)
+
+       dodoc Misc/{ACKS,HISTORY,NEWS} || die "dodoc failed"
+
+       if use examples; then
+               insinto /usr/share/doc/${PF}/examples
+               doins -r "${S}/Tools" || die "doins failed"
+       fi
+
+       newinitd "${FILESDIR}/pydoc.init" pydoc-${SLOT} || die "newinitd failed"
+       newconfd "${FILESDIR}/pydoc.conf" pydoc-${SLOT} || die "newconfd failed"
+
+       # Do not install empty directory.
+       rmdir "${ED}$(python_get_libdir)/lib-old"
+}
+
+pkg_preinst() {
+       if has_version "<${CATEGORY}/${PN}-${SLOT}" && ! has_version "${CATEGORY}/${PN}:2.6" && ! has_version "${CATEGORY}/${PN}:2.7"; then
+               python_updater_warning="1"
+       fi
+}
+
+eselect_python_update() {
+       local eselect_python_options
+       [[ "$(eselect python show)" == "python2."* ]] && eselect_python_options="--python2"
+
+       # Create python2 symlink.
+       eselect python update --python2 > /dev/null
+
+       eselect python update ${eselect_python_options}
+}
+
+pkg_postinst() {
+       eselect_python_update
+
+       python_mod_optimize -f -x "/(site-packages|test|tests)/" $(python_get_libdir)
+
+       if [[ "${python_updater_warning}" == "1" ]]; then
+               ewarn
+               ewarn "\e[1;31m************************************************************************\e[0m"
+               ewarn
+               ewarn "You have just upgraded from an older version of Python."
+               ewarn "You should run 'python-updater \${options}' to rebuild Python modules."
+               ewarn
+               ewarn "\e[1;31m************************************************************************\e[0m"
+               ewarn
+               ebeep 12
+       fi
+}
+
+pkg_postrm() {
+       eselect_python_update
+
+       python_mod_cleanup $(python_get_libdir)
+}